//+------------------------------------------------------------------+
//|                                             Risdyanto-Trader.mq4 |
//|                                 Copyright  2008, Risdyanto    
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Risdyanto"
#property link      ""

int numBars  = 10;
extern int lot  = 1;
extern int takeprofit =300;
extern int stop = 150;
extern bool PakeTrailing=true;
extern int TrailingStop=50;
extern int StartTrail=100;
int BatasOrder=3;
double open;
double support;
double resist;
string trendType;
int timeFrame = 5;
int maPeriod = 6;
int slippage = 3;
int demark=14;
bool tradebalance=false;
double MovingPeriod       = 80;
double MovingShift        = 0;
string mark;
bool pakejam=true;
int dari=4;
int sampe=9;
string filter;
int count;
double sss,pss;

int init() {

    ObjectCreate("lineSupport",OBJ_HLINE,0,0,0);
    ObjectSet("lineSupport",OBJPROP_COLOR,Red);
    ObjectSet("lineSupport",OBJPROP_WIDTH,2);
    
    ObjectCreate("lineResist",OBJ_HLINE,0,0,0);
    ObjectSet("lineResist",OBJPROP_COLOR,Blue);
    ObjectSet("lineResist",OBJPROP_WIDTH,2);
 return(0);
 }
int deinit(){
ObjectsDeleteAll();
return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
if(CheckTodaysOrders() >= BatasOrder){
return(0); // abort
}
  if (pakejam) 
  {bool is_siesta=false;
   if ( Hour()>= dari && Hour()<=sampe && DayOfWeek()>=1 && DayOfWeek()<=5 )
   is_siesta=true;}

  if (is_siesta==true) 
  {
  MarketAnalize();
  if(OrdersTotal()==0)
   CheckForOpen();
  else
   CheckForClose();
  }

   return(0);
}

void MarketAnalize()
{
 support = 100000;
 resist  = 0;
 
 for(int k = 1;k<=numBars;k++)
  {  if (support > iLow (Symbol(),timeFrame,k))
     support = iLow (Symbol(),timeFrame,k);
     if (resist < iHigh(Symbol(),timeFrame,k))
     resist  = iHigh(Symbol(),timeFrame,k);
  }  
  
 // ObjectSet("lineSupport",OBJPROP_PRICE1,support);
 // ObjectSet("lineResist" ,OBJPROP_PRICE1, resist);
  
 double MA = iMA(Symbol(),timeFrame,maPeriod,0,MODE_SMA,PRICE_CLOSE,0);
  
 // if(Open[1] < MA && Close[1] > MA)
  if (Ask > MA)
  { trendType = "bullish";  }
  //if(Open[1] > MA && Close[1] < MA)
  if (Bid < MA)
  { trendType = "bearish";  }
  
 
}

void CheckForOpen()
{RefreshRates();
  
   if ((iDeMarker(Symbol(),timeFrame,demark,0)>0.55)
     &&(iDeMarker(Symbol(),timeFrame,demark,1)<0.60)
      && iDeMarker(Symbol(),timeFrame,demark,0)> iDeMarker(Symbol(),timeFrame,demark,1)
       &&(trendType=="bullish")
     // &&(Ask>resist)
      )
     {  OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);
     if (tradebalance)
      {OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point); }
     }
 
    if ((iDeMarker(Symbol(),timeFrame,demark,0)<0.45) 
     &&(iDeMarker(Symbol(),timeFrame,demark,1)>0.40)
    && iDeMarker(Symbol(),timeFrame,demark,0)< iDeMarker(Symbol(),timeFrame,demark,1)
      &&(trendType=="bearish")
    //&& (Bid<support)
    )
     { OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point); 
     if (tradebalance)
      {OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);}
     }
   
    if (iDeMarker(Symbol(),timeFrame,demark,1)>0.9) 
     {OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point);}
     if (iDeMarker(Symbol(),timeFrame,demark,1)<0.1)  
     {OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);}
  sss=stop + 10;
  pss=takeprofit+50;
OrderSelect(0,SELECT_BY_POS);

if (OrderType()==OP_BUY)
   {  if ((iDeMarker(Symbol(),timeFrame,demark,0)>0.55)
     &&(iDeMarker(Symbol(),timeFrame,demark,1)<0.60))OrderSend(Symbol(),OP_SELLSTOP,lot,Bid-50*Point,3,Bid+sss*Point,Bid-pss*Point); }
if (OrderType()==OP_SELL)
   {   if ((iDeMarker(Symbol(),timeFrame,demark,0)<0.45) 
     &&(iDeMarker(Symbol(),timeFrame,demark,1)>0.40))OrderSend(Symbol(),OP_BUYSTOP,lot,Ask+50*Point,3,Ask-sss*Point,Ask+pss*Point);}   
     
}  

void CheckForClose()
{int total  = OrdersTotal();
  
  for (int cnt = total-1 ; cnt >= 0 ; cnt--)
  { OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
   
  if (OrderType()==OP_BUYSTOP) 
     { if ((iDeMarker(Symbol(),timeFrame,demark,0)>0.55) 
     &&(iDeMarker(Symbol(),timeFrame,demark,1)<0.60)) OrderDelete(OrderTicket());}
  if (OrderType()==OP_SELLSTOP)
     { if ((iDeMarker(Symbol(),timeFrame,demark,0)<0.45) 
     &&(iDeMarker(Symbol(),timeFrame,demark,1)>0.40)) OrderDelete(OrderTicket());}
  }   
 OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
 
if (PakeTrailing){
 if(OrderType()==OP_BUY)
 {
 if(Ask>OrderOpenPrice()+Point*StartTrail) 
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
          
              
  /* if((Ask>OrderOpenPrice()+Point*100)&&(OrderStopLoss()<(OrderOpenPrice()+Point*50)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*50,OrderTakeProfit(),0,Blue);
     if((Ask>OrderOpenPrice()+Point*200)&&(OrderStopLoss()<(OrderOpenPrice()+Point*100)))
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*100,OrderTakeProfit(),0,Blue);    
        if((Ask>OrderOpenPrice()+Point*350)&&(OrderStopLoss()<(OrderOpenPrice()+Point*300)))
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*300,OrderTakeProfit(),0,Blue);
          if((Ask>OrderOpenPrice()+Point*400)&&(OrderStopLoss()<(OrderOpenPrice()+Point*350)))
           OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*350,OrderTakeProfit(),0,Blue);*/
  }  
 if(OrderType()==OP_SELL)
 {  
  if(Bid<OrderOpenPrice()-Point*StartTrail) 
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           
   /*       if((Bid<OrderOpenPrice()-Point*100)&&(OrderStopLoss()>(OrderOpenPrice()-Point*50)))
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*50,OrderTakeProfit(),0,Blue);     
         if((Bid<OrderOpenPrice()-Point*200)&&(OrderStopLoss()>(OrderOpenPrice()-Point*150)))
        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*150,OrderTakeProfit(),0,Blue);     
       if((Bid<OrderOpenPrice()-Point*350)&&(OrderStopLoss()>(OrderOpenPrice()-Point*300)))
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*300,OrderTakeProfit(),0,Blue);     
     if((Bid<OrderOpenPrice()-Point*400)&&(OrderStopLoss()>(OrderOpenPrice()-Point*350)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*350,OrderTakeProfit(),0,Blue);   */ 
 } }    
//+------------------------------------------------------------------+
}

// function
int CheckTodaysOrders()
{
int TodaysOrders = 0;
for(int i = OrdersTotal()-1; i >=0; i--){
OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){
TodaysOrders += 1;
}
}
for(i = OrdersHistoryTotal()-1; i >=0; i--){
OrderSelect(i, SELECT_BY_POS,MODE_HISTORY);
if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){
TodaysOrders += 1
;
}
}
return(TodaysOrders);
}
 
//+------------------------------------------------------------------+

